#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>

void delay_ms(uint16_t x)
{
	uint8_t y, z;
	for ( ; x > 0 ; x--){
		for ( y = 0 ; y < 90 ; y++){
			for ( z = 0 ; z < 6 ; z++){
				asm volatile ("nop");
			}
		}
	}
}

void layers() {
	const int DEL_LAYER = 7000;
	int level = 0;

	// light layers
	for (level = 0; level < 4; level++) {
		PORTD = (1 << level);
		PORTA = PORTB = 0xFF;
		delay_ms(DEL_LAYER);
	}

	// light layers
	for (level = 2; level >= 0; level--) {
		PORTD = (1 << level);
		PORTA = PORTB =  0xFF;
		delay_ms(DEL_LAYER);
	}
}

void clear() {
	PORTA = PORTB = PORTD = 0;
}

void random_play() {
	int i;
	for (i = 0; i < 1000; i++) {
		PORTA = 1 << (rand() % 8);
		PORTB = 1 << (rand() % 8);
		PORTD = 1 << (rand() % 4);
		delay_ms(40);
	}
}

int main() {
	DDRA = DDRB = DDRC = DDRD = 0xff;
	while (1) {
		layers();
		random_play();
	}
	return 0;
}
